<?php

/**
 * @file
 * Hooks related to genpass module and password generation.
 */

/**
 * @addtogroup hooks
 * @{
 */

/**
 * Generate a password of a given length and return it.
 *
 * @param int $length
 *   The length of the password to return.
 *
 * @deprecated in genpass:8.x-1.2 and is removed from genpass:2.0.0. Use
 *   \Drupal\Core\Password\PasswordGeneratorInterface::generate() instead
 *   introduced in drupal:9.1.0 and genpass:2.0.0.
 *
 * @see https://www.drupal.org/project/genpass/issues/3383649
 * @see user_password()
 */
function hook_password($length) {
  // Generate a password using our method of $length.
  return genpass_password($length);
}

/**
 * Alter the character sets used in genpass_password().
 *
 * @param array $character_sets
 *   A array of strings which make up separate character sets.
 *
 * @throws \Drupal\genpass\InvalidCharacterSetsException.
 *   In the event that the character set is too small to be used. Minimum size
 *   is the length of the password.
 */
function hook_genpass_character_sets_alter(array &$character_sets) {

  // Add the similar characters back in to annoy users.
  $character_sets['annoyingly_similar'] .= '`|I1l0O';
}

/**
 * @} End of "addtogroup hooks".
 */
